#include <stdio.h> 
#include <pthread.h> 
#include <semaphore.h> 
#include <unistd.h> 

#define BUFLEN 40

sem_t mutex, empty, full; 
int buffer[BUFLEN];
int read_pos = 0;
int write_pos = 0;
int global_sum = 0;

void* produce (void* arg) { 
  int base = (int)arg;
  int i, item;
  for (i = 0; i < 50; i++) {
    item = base + i;
    sem_wait (&empty); 
    sem_wait (&mutex); 
    buffer[write_pos++] = item;
    if (write_pos == BUFLEN) write_pos = 0;
    sem_post(&mutex); 
    sem_post(&full); 
    usleep (100);
  }
} 

void* consume (void* arg) { 
  int i, item;
  for (i = 0; i < 50; i++) {
    sem_wait (&full); 
    sem_wait (&mutex);
    item = buffer[read_pos++];
    global_sum += item;
    printf ("%c%d(%d) ", 'a' + item/1000, item % 1000, read_pos-1);
    if (read_pos == BUFLEN) read_pos = 0;
    sem_post(&mutex); 
    sem_post(&empty); 
    usleep (100);
  }
} 


int main() { 
  sem_init(&mutex, 0, 1); 
  sem_init(&empty, 0, BUFLEN); 
  sem_init(&full,  0, 0); 
  pthread_t producers[10];
  pthread_t consumers[10];
  int i;
  for (i = 0; i < 10; i++) {
    pthread_create(&producers[i],NULL,produce,(void*)(i*1000)); 
  }
  for (i = 0; i < 10; i++) {
    pthread_create(&consumers[i],NULL,consume,NULL); 
  }
  for (i = 0; i < 10; i++) {
    pthread_join(producers[i],NULL); 
    pthread_join(consumers[i],NULL); 
  }

  sem_destroy(&mutex); 
  sem_destroy(&empty); 
  sem_destroy(&full); 
  printf ("\nglobal sum: %d\n", global_sum);
  return 0; 
} 


